/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the NewEvent type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &NewEvent{}

// NewEvent Event structure that can be sent to interaction. Event is always sent for specific contact, you can use one of possible identifiers related to contact:  - `contact_id` - Contact id from Slace system   - `com_channel_id` - Contact's concrete communication channel   - `convarsation_id` - Contact's conversation id  One of these values is required to send an event.
type NewEvent struct {
	// Random string will be generated if empty
	Id *string `json:"id,omitempty"`
	// Some common identifier of source (like module or app name)
	Source string `json:"source"`
	// Event name
	Type string `json:"type"`
	ChannelId string `json:"channel_id"`
	TransactionId *string `json:"transaction_id,omitempty"`
	ConversationId *string `json:"conversation_id,omitempty"`
	ContactId *string `json:"contact_id,omitempty"`
	ComChannelId *string `json:"com_channel_id,omitempty"`
	GatewayId *string `json:"gateway_id,omitempty"`
	// Current time will be set if empty
	Timestamp *time.Time `json:"timestamp,omitempty"`
	// Key value object with custom event parameters.
	Body map[string]interface{} `json:"body,omitempty"`
}

// NewNewEvent instantiates a new NewEvent object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNewEvent(source string, type_ string, channelId string) *NewEvent {
	this := NewEvent{}
	this.Source = source
	this.Type = type_
	this.ChannelId = channelId
	return &this
}

// NewNewEventWithDefaults instantiates a new NewEvent object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNewEventWithDefaults() *NewEvent {
	this := NewEvent{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *NewEvent) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NewEvent) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *NewEvent) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *NewEvent) SetId(v string) {
	o.Id = &v
}

// GetSource returns the Source field value
func (o *NewEvent) GetSource() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Source
}

// GetSourceOk returns a tuple with the Source field value
// and a boolean to check if the value has been set.
func (o *NewEvent) GetSourceOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Source, true
}

// SetSource sets field value
func (o *NewEvent) SetSource(v string) {
	o.Source = v
}

// GetType returns the Type field value
func (o *NewEvent) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *NewEvent) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *NewEvent) SetType(v string) {
	o.Type = v
}

// GetChannelId returns the ChannelId field value
func (o *NewEvent) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *NewEvent) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *NewEvent) SetChannelId(v string) {
	o.ChannelId = v
}

// GetTransactionId returns the TransactionId field value if set, zero value otherwise.
func (o *NewEvent) GetTransactionId() string {
	if o == nil || IsNil(o.TransactionId) {
		var ret string
		return ret
	}
	return *o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NewEvent) GetTransactionIdOk() (*string, bool) {
	if o == nil || IsNil(o.TransactionId) {
		return nil, false
	}
	return o.TransactionId, true
}

// HasTransactionId returns a boolean if a field has been set.
func (o *NewEvent) HasTransactionId() bool {
	if o != nil && !IsNil(o.TransactionId) {
		return true
	}

	return false
}

// SetTransactionId gets a reference to the given string and assigns it to the TransactionId field.
func (o *NewEvent) SetTransactionId(v string) {
	o.TransactionId = &v
}

// GetConversationId returns the ConversationId field value if set, zero value otherwise.
func (o *NewEvent) GetConversationId() string {
	if o == nil || IsNil(o.ConversationId) {
		var ret string
		return ret
	}
	return *o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NewEvent) GetConversationIdOk() (*string, bool) {
	if o == nil || IsNil(o.ConversationId) {
		return nil, false
	}
	return o.ConversationId, true
}

// HasConversationId returns a boolean if a field has been set.
func (o *NewEvent) HasConversationId() bool {
	if o != nil && !IsNil(o.ConversationId) {
		return true
	}

	return false
}

// SetConversationId gets a reference to the given string and assigns it to the ConversationId field.
func (o *NewEvent) SetConversationId(v string) {
	o.ConversationId = &v
}

// GetContactId returns the ContactId field value if set, zero value otherwise.
func (o *NewEvent) GetContactId() string {
	if o == nil || IsNil(o.ContactId) {
		var ret string
		return ret
	}
	return *o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NewEvent) GetContactIdOk() (*string, bool) {
	if o == nil || IsNil(o.ContactId) {
		return nil, false
	}
	return o.ContactId, true
}

// HasContactId returns a boolean if a field has been set.
func (o *NewEvent) HasContactId() bool {
	if o != nil && !IsNil(o.ContactId) {
		return true
	}

	return false
}

// SetContactId gets a reference to the given string and assigns it to the ContactId field.
func (o *NewEvent) SetContactId(v string) {
	o.ContactId = &v
}

// GetComChannelId returns the ComChannelId field value if set, zero value otherwise.
func (o *NewEvent) GetComChannelId() string {
	if o == nil || IsNil(o.ComChannelId) {
		var ret string
		return ret
	}
	return *o.ComChannelId
}

// GetComChannelIdOk returns a tuple with the ComChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NewEvent) GetComChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ComChannelId) {
		return nil, false
	}
	return o.ComChannelId, true
}

// HasComChannelId returns a boolean if a field has been set.
func (o *NewEvent) HasComChannelId() bool {
	if o != nil && !IsNil(o.ComChannelId) {
		return true
	}

	return false
}

// SetComChannelId gets a reference to the given string and assigns it to the ComChannelId field.
func (o *NewEvent) SetComChannelId(v string) {
	o.ComChannelId = &v
}

// GetGatewayId returns the GatewayId field value if set, zero value otherwise.
func (o *NewEvent) GetGatewayId() string {
	if o == nil || IsNil(o.GatewayId) {
		var ret string
		return ret
	}
	return *o.GatewayId
}

// GetGatewayIdOk returns a tuple with the GatewayId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NewEvent) GetGatewayIdOk() (*string, bool) {
	if o == nil || IsNil(o.GatewayId) {
		return nil, false
	}
	return o.GatewayId, true
}

// HasGatewayId returns a boolean if a field has been set.
func (o *NewEvent) HasGatewayId() bool {
	if o != nil && !IsNil(o.GatewayId) {
		return true
	}

	return false
}

// SetGatewayId gets a reference to the given string and assigns it to the GatewayId field.
func (o *NewEvent) SetGatewayId(v string) {
	o.GatewayId = &v
}

// GetTimestamp returns the Timestamp field value if set, zero value otherwise.
func (o *NewEvent) GetTimestamp() time.Time {
	if o == nil || IsNil(o.Timestamp) {
		var ret time.Time
		return ret
	}
	return *o.Timestamp
}

// GetTimestampOk returns a tuple with the Timestamp field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NewEvent) GetTimestampOk() (*time.Time, bool) {
	if o == nil || IsNil(o.Timestamp) {
		return nil, false
	}
	return o.Timestamp, true
}

// HasTimestamp returns a boolean if a field has been set.
func (o *NewEvent) HasTimestamp() bool {
	if o != nil && !IsNil(o.Timestamp) {
		return true
	}

	return false
}

// SetTimestamp gets a reference to the given time.Time and assigns it to the Timestamp field.
func (o *NewEvent) SetTimestamp(v time.Time) {
	o.Timestamp = &v
}

// GetBody returns the Body field value if set, zero value otherwise.
func (o *NewEvent) GetBody() map[string]interface{} {
	if o == nil || IsNil(o.Body) {
		var ret map[string]interface{}
		return ret
	}
	return o.Body
}

// GetBodyOk returns a tuple with the Body field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NewEvent) GetBodyOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Body) {
		return map[string]interface{}{}, false
	}
	return o.Body, true
}

// HasBody returns a boolean if a field has been set.
func (o *NewEvent) HasBody() bool {
	if o != nil && !IsNil(o.Body) {
		return true
	}

	return false
}

// SetBody gets a reference to the given map[string]interface{} and assigns it to the Body field.
func (o *NewEvent) SetBody(v map[string]interface{}) {
	o.Body = v
}

func (o NewEvent) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o NewEvent) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	toSerialize["source"] = o.Source
	toSerialize["type"] = o.Type
	toSerialize["channel_id"] = o.ChannelId
	if !IsNil(o.TransactionId) {
		toSerialize["transaction_id"] = o.TransactionId
	}
	if !IsNil(o.ConversationId) {
		toSerialize["conversation_id"] = o.ConversationId
	}
	if !IsNil(o.ContactId) {
		toSerialize["contact_id"] = o.ContactId
	}
	if !IsNil(o.ComChannelId) {
		toSerialize["com_channel_id"] = o.ComChannelId
	}
	if !IsNil(o.GatewayId) {
		toSerialize["gateway_id"] = o.GatewayId
	}
	if !IsNil(o.Timestamp) {
		toSerialize["timestamp"] = o.Timestamp
	}
	if !IsNil(o.Body) {
		toSerialize["body"] = o.Body
	}
	return toSerialize, nil
}

type NullableNewEvent struct {
	value *NewEvent
	isSet bool
}

func (v NullableNewEvent) Get() *NewEvent {
	return v.value
}

func (v *NullableNewEvent) Set(val *NewEvent) {
	v.value = val
	v.isSet = true
}

func (v NullableNewEvent) IsSet() bool {
	return v.isSet
}

func (v *NullableNewEvent) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNewEvent(val *NewEvent) *NullableNewEvent {
	return &NullableNewEvent{value: val, isSet: true}
}

func (v NullableNewEvent) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNewEvent) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


